#include  "mydoor.h"

int
main(int argc, char **argv)
{
  int    fd;
  long  ival, oval;
  door_arg_t  arg;
        struct stat     stat;
        struct door_info        info;

  if (argc != 3) err_quit("usage: client4 <server-pathname> <integer-value>");
  printf("start client, my PID: %d\n",(int) getpid());
  fd = open(argv[1], O_RDWR);    /* open the door */
  if (fd < 0) err_sys("open");
   /* print server-info */
  fstat(fd, &stat);
  if (S_ISDOOR(stat.st_mode) == 0)
                err_quit("pathname is not a door");
  door_info(fd, &info);
  printf("server PID = %ld, uniquifier = %ld",
             (long) info.di_target, (long) info.di_uniquifier);
  if (info.di_attributes & DOOR_LOCAL)
             printf(", DOOR_LOCAL");
  if (info.di_attributes & DOOR_PRIVATE)
                printf(", DOOR_PRIVATE");
  if (info.di_attributes & DOOR_REVOKED)
                printf(", DOOR_REVOKED");
  if (info.di_attributes & DOOR_UNREF)
                printf(", DOOR_UNREF");
        printf("\n");
   /* set up the arguments and pointer to result */
  ival = atol(argv[2]);
  arg.data_ptr = (char *) &ival;  /* data arguments */
  arg.data_size = sizeof(long);  /* size of data arguments */
  arg.desc_ptr = NULL;
  arg.desc_num = 0;
  arg.rbuf = (char *) &oval;    /* data results */
  arg.rsize = sizeof(long);    /* size of data results */
   /* call server procedure and print result */
  if (door_call(fd, &arg)<0) err_sys("door_call");
  printf("&oval = %p, data_ptr = %p, rbuf = %p, rsize  = %ld\n",
                   &oval, arg.data_ptr, arg.rbuf, arg.rsize);
  printf("result: %ld\n", *((long *) arg.data_ptr));
  exit(0);
}
